2026-06-26  Release Manager

	* GCC 14.4.0 released.

2026-05-05  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2026-05-05  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/125089
	* types.cc (finish_aggregate_mode): Explicitly set TYPE_MODE of
	non-POD types here.
	(finish_aggregate_type): Propagate TREE_ADDRESSABLE to all variants.
	(TypeVisitor::visit (TypeStruct *)): Set TREE_ADDRESSABLE before
	visiting struct members.

2026-02-08  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2026-02-08  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/124026
	* expr.cc (ExprVisitor::visit (FuncExp *)): Always convert function
	literal to a delegate if the expression expects one.

2026-01-30  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2026-01-30  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/123264
	* types.cc (finish_aggregate_type): Propagate struct TYPE_NAME to all
	TYPE_NEXT_VARIANT types.

2026-01-29  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2026-01-29  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/123407
	* decl.cc (get_symbol_decl): Handle declarations with matching
	assembler names, but different TREE_CODE.

2026-01-29  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2026-01-29  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/123046
	* d-codegen.cc (build_address): Return `null' when generating the
	address of a `noreturn' declaration.
	(d_build_call): Compare TYPE_MAIN_VARIANT of type with `noreturn'.
	* decl.cc (get_fndecl_arguments): Likewise.
	* types.cc (finish_aggregate_mode): Likewise.
	(TypeVisitor::visit (TypeFunction *)): Likewise.

2026-01-29  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2026-01-29  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/123349
	* d-spec.cc (lang_specific_driver): Use xstrdup to copy -defaultlib
	and -debuglib argument, and unconditionally free the old value.

2026-01-28  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2025-04-15  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/119799
	* decl.cc (DeclVisitor::visit (VarDeclaration *)): Check front-end
	type size before building the VAR_DECL.  Allow C symbols to have a
	size of `0'.

2026-01-28  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2026-01-28  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/123419
	* expr.cc (ExprVisitor::visit (VarExp *)): Adjust assertion.

2026-01-28  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2026-01-28  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/123798
	* types.cc (insert_aggregate_bitfield): Set DECL_NONADDRESSABLE_P and
	DECL_PADDING_P on bit-field decls.
	(finish_aggregate_type): Pass the aligned bit offset to layout_decl.

2026-01-28  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2026-01-28  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/121477
	* d-codegen.cc (d_mark_addressable): Give an error if taking the
	address of a DECL_BIT_FIELD.

2026-01-28  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2026-01-28  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/123422
	* expr.cc (ExprVisitor::visit (ArrayLiteralExp *)): Don't add
	TARGET_EXPR around constructor.
	* toir.cc (IRVisitor::visit (ReturnStatement *)): Recognize more
	patterns for return value optimization.

2026-01-27  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2026-01-27  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/120096
	* expr.cc (ExprVisitor::visit (ArrayLiteralExp *)): Include saved side
	effects in expression result.

2025-05-23  Release Manager

	* GCC 14.3.0 released.

2025-04-19  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2025-04-15  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/119826
	* types.cc (TypeVisitor::visit (TypeEnum *)): Propagate flags of main
	enum types to all forward-referenced variants.

2025-04-19  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2025-04-15  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/119817
	* imports.cc (ImportVisitor::visit (OverloadSet *)): Don't push
	NULL_TREE to vector of import symbols.

2025-04-19  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2025-04-09  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/118309
	* modules.cc: Include debug.h
	(d_finish_compilation): Call debug_hooks->type_decl on all TYPE_DECLs.
	* types.cc: Remove toplev.h include.
	(finish_aggregate_type): Don't call rest_of_type_compilation or
	rest_of_decl_compilation on type.
	(TypeVisitor::visit (TypeEnum *)): Likewise.

2025-03-31  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2025-03-31  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/117002
	* decl.cc (aggregate_initializer_decl): Set explicit decl alignment of
	class instance.
	* expr.cc (ExprVisitor::visit (NewExp *)): Likewise.
	* types.cc (TypeVisitor::visit (TypeClass *)): Mark the record type of
	classes as packed.

2025-03-23  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2025-03-23  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/117621
	* types.cc (finish_aggregate_type): Propagate TYPE_PACKED to variants.

2025-03-20  Iain Buclaw  <ibuclaw@gdcproject.org>

	* dmd/MERGE: Merge upstream dmd af92b68a81.
	* dmd/VERSION: Bump version to v2.108.1.

2025-03-11  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2025-03-11  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/119139
	* decl.cc (get_symbol_decl): Don't set TREE_READONLY for __result
	declarations.

2025-03-02  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2025-02-28  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/116961
	* d-codegen.cc (build_float_cst): Change new_value type from real_t to
	real_value.
	* d-ctfloat.cc (CTFloat::fabs): Default initialize the return value.
	(CTFloat::ldexp): Likewise.
	(CTFloat::parse): Likewise.
	* d-longdouble.cc (longdouble::add): Likewise.
	(longdouble::sub): Likewise.
	(longdouble::mul): Likewise.
	(longdouble::div): Likewise.
	(longdouble::mod): Likewise.
	(longdouble::neg): Likewise.
	* d-port.cc (Port::isFloat32LiteralOutOfRange): Likewise.
	(Port::isFloat64LiteralOutOfRange): Likewise.

2025-02-10  Arsen Arsenović  <arsen@aarsen.me>

	Backported from master:
	2025-01-29  Arsen Arsenović  <arsen@aarsen.me>
		    Jakub Jelinek  <jakub@redhat.com>

	PR d/118477
	* Make-lang.in (DCOMPILE, DPOSTCOMPILE): Use $(basename $(@F))
	instead of $(*F).

2025-01-20  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2025-01-20  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/114434
	* expr.cc (ExprVisitor::visit (PtrExp *)): Get the offset as a
	dinteger_t rather than a size_t.
	(ExprVisitor::visit (SymOffExp *)): Likewise.

2025-01-16  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2025-01-16  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/115249
	* typeinfo.cc (create_tinfo_types): Update internal Typenfo
	representation.
	(TypeInfoVisitor::visit (TypeInfoClassDeclaration *)): Likewise.

2025-01-16  Iain Buclaw  <ibuclaw@gdcproject.org>

	Backported from master:
	2025-01-16  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/116373
	* dmd/expressionsem.d (resolveLoc): Check for null pointer before
	resolving bounds of slice.

2024-08-01  Release Manager

	* GCC 14.2.0 released.

2024-05-07  Release Manager

	* GCC 14.1.0 released.

2024-04-19  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/111650
	* decl.cc (get_fndecl_arguments): Move generation of frame type to ...
	(DeclVisitor::visit (FuncDeclaration *)): ... here, after the call to
	build_closure.

2024-04-06  Iain Buclaw  <ibuclaw@gdcproject.org>

	* dmd/MERGE: Merge upstream dmd b65767825f.
	* dmd/VERSION: Bump version to v2.108.0.

2024-03-17  Iain Buclaw  <ibuclaw@gdcproject.org>

	* dmd/MERGE: Merge upstream dmd 855353a1d9.
	* dmd/VERSION:

2024-03-10  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/112285
	PR d/112290
	* d-target.cc (Target::preferPassByRef): Return true for all static
	array and struct types.

2024-03-03  Iain Buclaw  <ibuclaw@gdcproject.org>

	* dmd/MERGE: Merge upstream dmd f8bae04558.
	* dmd/VERSION: Bump version to v2.108.0-beta.1.
	* d-builtins.cc (build_frontend_type): Update for new front-end
	interface.
	* d-codegen.cc (build_assert_call): Likewise.
	* d-convert.cc (d_array_convert): Likewise.
	* decl.cc (get_vtable_decl): Likewise.
	* expr.cc (ExprVisitor::visit (EqualExp *)): Likewise.
	(ExprVisitor::visit (VarExp *)): Likewise.
	(ExprVisitor::visit (ArrayLiteralExp *)): Likewise.
	(ExprVisitor::visit (AssocArrayLiteralExp)): Likewise.
	* intrinsics.cc (build_shuffle_mask_type): Likewise.
	(maybe_warn_intrinsic_mismatch): Likewise.
	* runtime.cc (get_libcall_type): Likewise.
	* typeinfo.cc (TypeInfoVisitor::layout_string): Likewise.
	(TypeInfoVisitor::visit(TypeInfoTupleDeclaration *)): Likewise.

2024-03-03  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/114171
	* d-codegen.cc (lower_struct_comparison): Keep alignment of original
	type in reinterpret cast for comparison.

2024-02-25  Iain Buclaw  <ibuclaw@gdcproject.org>

	* dmd/MERGE: Merge upstream dmd ceff48bf7d.

2024-02-17  Iain Buclaw  <ibuclaw@gdcproject.org>

	* dmd/MERGE: Merge upstream dmd 9471b25db9.
	* dmd/VERSION: Bump version to v2.107.1-rc.1.
	* Make-lang.in (D_FRONTEND_OBJS): Add d/cxxfrontend.o.
	* d-attribs.cc (build_attributes): Update for new front-end interface.
	* d-builtins.cc (build_frontend_type): Likewise.
	(strip_type_modifiers): Likewise.
	(covariant_with_builtin_type_p): Likewise.
	* d-codegen.cc (declaration_type): Likewise.
	(parameter_type): Likewise.
	(build_array_struct_comparison): Likewise.
	(void_okay_p): Likewise.
	* d-convert.cc (convert_expr): Likewise.
	(check_valist_conversion): Likewise.
	* d-lang.cc (d_generate_ddoc_file): Likewise.
	(d_parse_file): Likewise.
	* d-target.cc (TargetCPP::toMangle): Likewise.
	(TargetCPP::typeInfoMangle): Likewise.
	(TargetCPP::thunkMangle): Likewise.
	(TargetCPP::parameterType): Likewise.
	* decl.cc (d_mangle_decl): Likewise.
	(DeclVisitor::visit): Likewise.
	(DeclVisitor::visit (CAsmDeclaration *)): New method.
	(get_symbol_decl): Update for new front-end interface.
	(layout_class_initializer): Likewise.
	* expr.cc (ExprVisitor::visit): Likewise.
	* intrinsics.cc (maybe_set_intrinsic): Likewise.
	(expand_intrinsic_rotate): Likewise.
	* modules.cc (layout_moduleinfo_fields): Likewise.
	(layout_moduleinfo): Likewise.
	* runtime.cc (get_libcall_type): Likewise.
	* typeinfo.cc (make_frontend_typeinfo): Likewise.
	(TypeInfoVisitor::visit): Likewise.
	(create_typeinfo): Likewise.
	* types.cc (same_type_p): Likewise.
	(build_ctype): Likewise.

2024-02-12  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/113125
	* types.cc (TypeVisitor::visit (TypeStruct *)): Generate TYPE_DECL and
	apply UDAs to opaque struct declarations.

2024-02-12  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/113772
	* dmd/MERGE: Merge upstream dmd 11240a9663.
	* d-builtins.cc (build_frontend_type): Update for new front-end
	interface.
	* types.cc (same_type_p): Likewise.

2024-02-12  Iain Buclaw  <ibuclaw@gdcproject.org>

	PR d/113758
	* d-codegen.cc (d_build_call): Force a TARGET_EXPR when callee
	destorys its arguments.
	* decl.cc (DeclVisitor::visit (VarDeclaration *)): Set
	SET_DECL_VALUE_EXPR on the temporary variable to make it a placeholder
	for the TARGET_EXPR_SLOT.

2024-02-04  Iain Buclaw  <ibuclaw@gdcproject.org>

	* dmd/MERGE: Merge upstream dmd a6f1083699.
	* dmd/VERSION: Bump version to v2.107.0
	* Make-lang.in (D_FRONTEND_OBJS): Add d/pragmasem.o.
	* d-builtins.cc (strip_type_modifiers): Update for new front-end
	interface.
	* d-codegen.cc (declaration_type): Likewise.
	(parameter_type): Likewise.
	* d-target.cc (TargetCPP::parameterType): Likewise.
	* expr.cc (ExprVisitor::visit (IndexExp *)): Likewise.
	(ExprVisitor::visit (VarExp *)): Likewise.
	(ExprVisitor::visit (AssocArrayLiteralExp *)): Likewise.
	* runtime.cc (get_libcall_type): Likewise.
	* typeinfo.cc (TypeInfoVisitor::visit (TypeInfoConstDeclaration *)):
	Likewise.
	(TypeInfoVisitor::visit (TypeInfoInvariantDeclaration *)): Likewise.
	(TypeInfoVisitor::visit (TypeInfoSharedDeclaration *)): Likewise.
	(TypeInfoVisitor::visit (TypeInfoWildDeclaration *)): Likewise.
	* types.cc (build_ctype): Likewise.

2024-02-03  Iain Buclaw  <ibuclaw@gdcproject.org>

	* dmd/MERGE: Merge upstream dmd e770945277.
	* Make-lang.in (D_FRONTEND_OBJS): Add d/basicmangle.o, d/enumsem.o,
	d/funcsem.o, d/templatesem.o.
	* d-builtins.cc (build_frontend_type): Update for new front-end
	interface.
	* d-codegen.cc (declaration_type): Likewise.
	(parameter_type): Likewise.
	* d-incpath.cc (add_globalpaths): Likewise.
	(add_filepaths): Likewise.
	(add_import_paths): Likewise.
	* d-lang.cc (d_init_options): Likewise.
	(d_handle_option): Likewise.
	(d_parse_file): Likewise.
	* decl.cc (DeclVisitor::finish_vtable): Likewise.
	(DeclVisitor::visit (FuncDeclaration *)): Likewise.
	(get_symbol_decl): Likewise.
	* expr.cc (ExprVisitor::visit (StringExp *)): Likewise.
	Implement support for 8-byte hexadecimal strings.
	* typeinfo.cc (create_tinfo_types): Update internal TypeInfo
	representation.
	(TypeInfoVisitor::visit (TypeInfoConstDeclaration *)): Update for new
	front-end interface.
	(TypeInfoVisitor::visit (TypeInfoInvariantDeclaration *)): Likewise.
	(TypeInfoVisitor::visit (TypeInfoSharedDeclaration *)): Likewise.
	(TypeInfoVisitor::visit (TypeInfoWildDeclaration *)): Likewise.
	(TypeInfoVisitor::visit (TypeInfoClassDeclaration *)): Move data for
	TypeInfo_Class.nameSig to the end of the object.
	(create_typeinfo): Update for new front-end interface.

2024-02-02  Iain Buclaw  <ibuclaw@gdcproject.org>

	* dmd/MERGE: Merge upstream dmd bce5c1f7b5.
	* d-attribs.cc (build_attributes): Update for new front-end interface.
	* d-lang.cc (d_parse_file): Likewise.
	* decl.cc (DeclVisitor::visit (VarDeclaration *)): Likewise.
	* expr.cc (build_lambda_tree): New function.
	(ExprVisitor::visit (FuncExp *)): Use build_lambda_tree.
	(ExprVisitor::visit (SymOffExp *)): Likewise.
	(ExprVisitor::visit (VarExp *)): Likewise.
	* typeinfo.cc (create_tinfo_types): Add two ulong fields to internal
	TypeInfo representation.
	(TypeInfoVisitor::visit (TypeInfoClassDeclaration *)): Emit stub data
	for TypeInfo_Class.nameSig.
	(TypeInfoVisitor::visit (TypeInfoStructDeclaration *)): Update for new
	front-end interface.

2024-02-02  Iain Buclaw  <ibuclaw@gdcproject.org>

	* dmd/MERGE: Merge upstream dmd d8e3976a58.
	* dmd/VERSION: Bump version to v2.107.0-beta.1.
	* d-lang.cc (d_parse_file): Update for new front-end interface.
	* modules.cc (struct module_info): Add standalonectors.
	(build_module_tree): Implement @standalone.
	(register_module_decl): Likewise.

2024-02-02  Iain Buclaw  <ibuclaw@gdcproject.org>

	* dmd/MERGE: Merge upstream dmd f1a045928e.
	* dmd/VERSION: Bump version to v2.106.1-rc.1.
	* gdc.texi (fignore-unknown-pragmas): Update documentation.
	* d-builtins.cc (covariant_with_builtin_type_p): Update for new
	front-end interface.
	* d-lang.cc (d_parse_file): Likewise.
	* typeinfo.cc (make_frontend_typeinfo): Likewise.

2024-01-04  David Malcolm  <dmalcolm@redhat.com>

	* lang.opt.urls: New file, autogenerated by
	regenerate-opt-urls.py.

2024-01-03  Jakub Jelinek  <jakub@redhat.com>

	* gdc.texi: Bump @copyrights-d year.


Copyright (C) 2024 Free Software Foundation, Inc.

Copying and distribution of this file, with or without modification,
are permitted in any medium without royalty provided the copyright
notice and this notice are preserved.
